# -*- coding: utf-8 -*-
"""
Created on Sat Jun  9 19:57:23 2012

@author: sean
"""
import numpy as np
import pylab as py
import cPickle as pickle


def InitSimulation():
    global EMat, E, Eab, M, NChains, Types, Names, rho, N, L, Corners, T, PosRecord
        
    EMat = [[E, Eab],[Eab,E]]

    CopolymerNames = ['N']*M
    CopolymerTypes = [0]*M

    Types = CopolymerTypes * NChains + [1]*(N-M*NChains)
    Names = CopolymerNames * NChains + ['O']*(N-M*NChains) + ['C']*8
    
    PosRecord = []
    
    p = [2,-2,0,-N/rho]
    L = np.float(np.roots(p)[0])
    
    Corners = [ [-L,-L/2.0,-L/2.0],
                [L,-L/2.0,-L/2.0],
                [L,-L/2.0,L/2.0],
                [-L,-L/2.0,L/2.0],
                
                [-L,L/2.0,-L/2.0],
                [L,L/2.0,-L/2.0],
                [L,L/2.0,L/2.0],
                [-L,L/2.0,L/2.0],
    ]   

def GetDisplacementFromTarget(Pos):
    global M, xtarget
    r = np.array((Pos[0:M]),float)
    dx = np.mean(xtarget-r[:,0])
    return dx    
    
#### YOUR CODE HERE ####
kx=5

k=3000.0
E = 1
Eab = 1
EMat = []

N = 300
M = 40
NChains = 1

Types = []
Names = []

rho = 0.7
L = 1.0

Corners = []   

#Statistics Stuff
RhoZ = []
Rg = []
stats = [RhoZ, Rg]

PosRecord = []

#L = (N/rho)**(1./3.)
T = 1.2
Run = 1
XTargets = np.arange(-0.5,4.0,0.75)

InitSimulation()
M=60
NA=60

ctot = []
for rho in [0.65,0.7]:
    for T in [1.1,1.2]:
        Fs = []
        for Run in range(1):    
            ctot = []
    
            vals = []
            for xtarget in XTargets :
                FileName = "Pos-x={}-M={}-NA={}-Run={}-T={}-rho={}".format(xtarget,M,NA,Run,T,rho)
    #            FileName = "Pos-x={}-M={}-Run={}".format(xtarget,M,Run)
                f = file("Data/"+FileName,'r')
                [ChainPositions, E]= pickle.load(f)
                f.close()
                    
                xt = np.mean(ChainPositions,axis=1)
                n, bins = py.histogram(xt[:,0],16,[min(XTargets)-0.5,max(XTargets)+0.5])
                
                if ctot == []:
                    ctot = np.array(n)
                else:
                    ctot = ctot + np.array(n)
                        
                midbins = np.array([(bins[i+1] + bins[i]) / 2.0 for i in range(len(bins)-1) ])
                n = np.log(1.0*n/np.sum(n)) + T*kx/2.0*np.square((midbins-xtarget))
                vals.append(np.array(-n))
            
            eta = [-T*kx/2.0*np.square(midbins-XTarget) for XTarget in XTargets]
            eta = np.array(eta)
                        
            etamax = np.max(eta)
            eta = eta - np.max(eta)
            n=125
            
            F = np.random.rand(len(ctot))
            A = np.random.rand(4)
            for i in range(2500):
                A[0] = 0
                a = np.log(ctot) - np.log(n) - etamax
                b = -np.log(np.sum(np.exp([eta[j]+A[j] for j in range(len(A))]),axis=0))
                FNew = np.array(-a-b)
        
                if np.linalg.norm(F - FNew) < 0.001*np.linalg.norm(F):
                    break
                
                F = np.array(FNew)
                a = np.array([np.log(np.sum(np.exp(-(F)+etaj))) for etaj in eta],float)
                A = -a-etamax
            Fs.append(F)
        avg = np.mean(Fs,axis=0)
        sq = np.mean(np.square(Fs),axis=0)
        var = np.sqrt(sq - np.square(avg))
        #py.clf()
        py.errorbar(midbins,avg-np.min(avg),yerr=var,label="$N_A$={}".format(NA))
        #py.savefig("F(z) w errs M={}.png".format(M))
py.xlim(-L,L)
py.title("Potentials of Mean Force along Z Axis")
py.xlabel("Z-Position",fontsize=18)
py.ylabel(r'$\beta \/\left(F(z)-F(0)\right)$',fontsize=18)
py.legend()
py.savefig("F(z) new M={}.png".format(M))
print "Done"
